/*****************************************************************************\
 *
 * rpLib	- graphic library for rapid development of graphical applications
 *
 * Author:	Pavel Gunia (xgunia01 @ stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/


#ifndef RPGEOMETRYNODE_H
#define RPGEOMETRYNODE_H


#include "rpscenenode.h"
#include "rpGeometryBuffer.h"
#include "rpTexture.h"
#include <deque>


class rpGeometryNode :
	public rpSceneNode
{
public:
	rpGeometryNode(rpSceneNode *, rpSceneManager *);
	virtual ~rpGeometryNode(void);

    void	setTexture(rpTexture *);

	rpGeometryBuffer*	getCurrentGeometry();
	
	std::deque<rpGeometryBuffer *>				geometry_list;
	std::deque<rpGeometryBuffer *>::iterator	current_geometry;

	virtual void preRender();
	virtual void Render();


protected:
	rpTexture	*texture;

};
#endif