/*****************************************************************************\
 *
 * rpLib	- graphic library for rapid development of graphical applications
 *
 * Author:	Pavel Gunia (xgunia01 @ stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/


#ifndef RPPHYSICSCOLLISION_H
#define RPPHYSICSCOLLISION_H
#include "rpbase.h"
#include "rpPhysicsWorld.h"
#include "rpMatrix.h"

class rpGeometryBuffer;

enum E_PCOLLISION_TYPE {
	E_PCT_NONE = 0,
	E_PCT_BOX,
	E_PCT_SPHERE,
	E_PCT_CONE,
	E_PCT_CAPSULE,
	E_PCT_CYLINDER,
	E_PCT_CONVEX_HULL,
	E_PCT_STATIC_GEOMETRY,
	E_PCT_LEVEL,
    E_PCT_COUNT
};
class rpPhysicsCollision :
	public rpBase
{
public:
	rpPhysicsCollision(rpPhysicsWorld *, E_PCOLLISION_TYPE, f32, f32, f32, rpMatrix * = NULL);
	rpPhysicsCollision(rpPhysicsWorld *, E_PCOLLISION_TYPE, f32, f32, rpMatrix* = NULL);
	rpPhysicsCollision(rpPhysicsWorld *, E_PCOLLISION_TYPE, rpGeometryBuffer *, rpMatrix* = NULL);
	virtual ~rpPhysicsCollision(void);


	bool				isFine();
	NewtonCollision*	getNewtonCollision();

	E_PCOLLISION_TYPE		collision_type;

protected:
	rpPhysicsWorld*			pWorld;
	NewtonCollision*		pCollision;
		
};

#endif