/*****************************************************************************\
 *
 * rpLib	- graphic library for rapid development of graphical applications
 *
 * Author:	Pavel Gunia (xgunia01 @ stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/


#ifndef RPRESOURCEMANAGER_H
#define RPRESOURCEMANAGER_H


#include "rpbase.h"
#include "rpVideoDriver.h"
#include "rpTexture.h"
#include "rpGeometryBuffer.h"
#include <string.h>

#include <map>

struct sC8comp
{
  bool operator()(const c8* s1, const c8* s2) const
  {
    return strcmp(s1, s2) < 0;
  }
};

class rpResourceManager :
	public rpBase
{
public:
	rpResourceManager(rpVideoDriver *vD){
		video_driver = vD;
	}
	~rpResourceManager(void);

	rpGeometryBuffer *getGeometryBuffer(const c8 *_file, bool hbuffer = false);
	rpGeometryBuffer *newGeometryBuffer(const c8 *_file, bool hbuffer = false);

	rpTexture		 *getTexture(const c8 *_file);
	rpTexture		 *newTexture(const c8 *_file);



protected:
	rpVideoDriver *video_driver;
    
	std::map<const c8 *, rpTexture *>					textures_list;
	std::map<const c8 *, rpTexture *>::iterator			textures_list_it;

	std::map<const c8 *, rpGeometryBuffer *>			geobuffer_list;
	std::map<const c8 *, rpGeometryBuffer *>::iterator	geobuffer_list_it;

};

#endif