/*****************************************************************************\
 *
 * rpLib	- graphic library for rapid development of graphical applications
 *
 * Author:	Pavel Gunia (xgunia01 @ stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/


#include "include\rplightnode.h"

rpLightNode::rpLightNode(rpSceneNode *sN, rpSceneManager *sM):rpSceneNode(sN, sM)
{
	// default values
	diffuseColor.set(1.0,1.0,1.0);
	specularColor.set(1.0,1.0,1.0);
	ambientColor.set(0.0,0.0,0.0);
	radius = 10.0;

}

rpLightNode::~rpLightNode(void)
{
}

// RENDER PASS
void rpLightNode::preRender()
{
	
	// 'pre-render' all children nodes
	if (visible) {
		
		updateTransformation();

		// hierarchy transformations
		transformation.copyTo(absolute_transformation);
		
		// if we have a parent node apply it's transformation to us
		if (parent)
			absolute_transformation.mult(parent->absolute_transformation);

			
		// set up the light via the video driver
		if (scene_manager->video_driver)
			scene_manager->video_driver->addDynamicLight(this);

		
		for (children_it = children.begin();children_it != children.end(); children_it++) {
			if (*children_it)	(*children_it)->preRender();
		}
	}	
}
void rpLightNode::Render()
{
	   

}
